//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Uexhaustivos.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#include <stdio.h>
TForm1 *Form1;
const int tamCuad=10;
const int numCuadros=30;// numero de cuadros por lado
const int ESPACIO=0;
const int PARED=1;
const int INICIO=2;
const int FINAL=3;

void TForm1::cuadricular(void)
   {
      for (int i=0;i<Image1->Height;i++)
         {
            Image1->Canvas->MoveTo(0,i*(tamCuad+1));
            Image1->Canvas->LineTo(Image1->Width-1,i*(tamCuad+1));
         }
      for (int i=0;i<Image1->Width;i++)
         {
            Image1->Canvas->MoveTo(i*(tamCuad+1),0);
            Image1->Canvas->LineTo(i*(tamCuad+1),Image1->Height-1);
         }
   }

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
   cuadricular();
   mapa=(int **)malloc(numCuadros*sizeof(int *));
   padre=(int **)malloc(numCuadros*sizeof(int *));
   for (int i=0;i<numCuadros;i++)
      {
         mapa[i]=(int *)malloc(numCuadros*sizeof(int));
         padre[i]=(int *)malloc(numCuadros*sizeof(int));
         for (int j=0;j<numCuadros;j++)
            mapa[i][j]=0;
      }
}
//---------------------------------------------------------------------------

void TForm1::rellenarCuadrito(int fil, int col, TColor c)
   {
      Image1->Canvas->Brush->Color=c;
      Image1->Canvas->Rectangle(col*(tamCuad+1),fil*(tamCuad+1),(col+1)*(tamCuad+1)+1,(fil+1)*(tamCuad+1)+1);
      Image1->Canvas->Brush->Color=clWhite;
   }

void TForm1::fijarInicio(int fil, int col)
   {
      if (mapa[fil][col]!=0)//espacio libre
         return;
      if (inicioFijo)
         {
            mapa[inicio.fil][inicio.col]=0;
            rellenarCuadrito(inicio.fil, inicio.col, clWhite);
         }
      else
         inicioFijo=true;
      mapa[fil][col]=INICIO;
      rellenarCuadrito(fil, col, clBlue);
      inicio.fil=fil;
      inicio.col=col;
   }

void TForm1::fijarFinal(int fil, int col)
   {
      if (mapa[fil][col]!=0)//espacio libre
         return;
      if (finalFijo)
         {
            mapa[final.fil][final.col]=0;
            rellenarCuadrito(final.fil, final.col, clWhite);
         }
      else
         finalFijo=true;
      mapa[fil][col]=FINAL;
      rellenarCuadrito(fil, col, clRed);
      final.fil=fil;
      final.col=col;
   }

void TForm1::colocarCuadrito(int c, int fil, int col)
   {
      switch(c)
      {
         case 0://espacio
            if (mapa[fil][col]!=1)//solo podemos quitar paredes
               return;
            mapa[fil][col]=0;
            rellenarCuadrito(fil,col,clWhite);
            break;
         case 1://pared
            if (mapa[fil][col]!=0)//solo podemos colcar paredes en espacios vacios
               return;
            rellenarCuadrito(fil,col,clBlack);
            mapa[fil][col]=1;
            break;
         case 2://inicio
            fijarInicio(fil, col);
            break;
         case 3://final
            fijarFinal(fil, col);
            break;
      }
   }
void __fastcall TForm1::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   int fil, col;
   col=X/(tamCuad+1);
   fil=Y/(tamCuad+1);
   colocarCuadrito(RadioGroup1->ItemIndex, fil, col);


}
//---------------------------------------------------------------------------


Selem* generarHijo(Selem *padre, int n)
   //genera el hijo "n" de "padre", si no genero todos a la vez, es posible optimizar la busqueda despues...
   {
      Selem *hijo;
      switch (n)
         {
            case 0:     //arriba
               if (padre->fil>0)     //el padre no esta en la primera fila
                  {
                     hijo=new Selem;
                     hijo->fil=padre->fil-1;
                     hijo->col=padre->col;
                     return hijo;
                  }
               break;
            case 1:     //izquierda
               if (padre->col>0)    //el padre no esta en la primera columna
                  {
                     hijo=new Selem;
                     hijo->fil=padre->fil;
                     hijo->col=padre->col-1;
                     return hijo;
                  }
               break;
            case 2:     //abajo
               if (padre->fil < (numCuadros-1))
                  {
                     hijo=new Selem;
                     hijo->fil=padre->fil+1;
                     hijo->col=padre->col;
                     return hijo;
                  }
               break;
            case 3:     //derecha
               if (padre->col < (numCuadros-1))
                  {
                     hijo=new Selem;
                     hijo->fil=padre->fil;
                     hijo->col=padre->col+1;
                     return hijo;
                  }
               break;
         }
      return NULL;
   }

void TForm1::mostrarRuta(void)
   {
      Scelda actual;
      int aux=padre[final.fil][final.col];
      actual.fil=aux/numCuadros;
      actual.col=aux%numCuadros;
      while (actual.fil!=inicio.fil || actual.col!=inicio.col)
         {
            rellenarCuadrito(actual.fil,actual.col,clGreen);
            aux=padre[actual.fil][actual.col];
            actual.fil=aux/numCuadros;
            actual.col=aux%numCuadros;

         }
   }

void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
   //busqueda en amplitud
   if (!inicioFijo || !finalFijo)
      return;
   for (int i=0;i<numCuadros;i++)
      for (int j=0;j<numCuadros;j++)
         {
            padre[i][j]=-1;
            if(mapa[i][j]==0)
               rellenarCuadrito(i,j,clWhite);
         }
   Ccola *cola;
   Selem *e;
   e=new Selem;
   e->fil=inicio.fil;
   e->col=inicio.col;
   cola=new Ccola();
   cola->insertar(e);

   Selem *P, *H;
   while(!cola->vacia())
      {
         P=cola->siguiente();
         if (mapa[P->fil][P->col]==FINAL)//ya llegamos!!
            {
               cola->vaciar();
               StatusBar1->SimpleText="Camino ptimo encontrado.";
               mostrarRuta();
               return;
            }
         for (int i=0;i<4;i++)
            {
              H=generarHijo(P,i);
              if (H!=NULL && mapa[H->fil][H->col]!=1 && padre[H->fil][H->col]==-1)
              //existe el hijo, es un espacio vacio y no ha sido visitado
                 {
                    padre[H->fil][H->col]=P->fil*numCuadros+P->col;
                    cola->insertar(H);
                 }
            }

      }
   StatusBar1->SimpleText=AnsiString("No se encontr el camino de (")+
   (((AnsiString(inicio.fil)+", ")+inicio.col)+") a (")+
   ((AnsiString(final.fil)+", ")+final.col)+")";



}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
   if (!inicioFijo || !finalFijo)
      return;
   for (int i=0;i<numCuadros;i++)
      for (int j=0;j<numCuadros;j++)
         {
            padre[i][j]=-1;
            if(mapa[i][j]==0)
               rellenarCuadrito(i,j,clWhite);
         }
   Cpila *pila;
   Selem *e;
   e=new Selem;
   e->fil=inicio.fil;
   e->col=inicio.col;
   pila=new Cpila();
   pila->insertar(e);

   Selem *P, *H;
   while(!pila->vacia())
      {
         P=pila->siguiente();
         if (mapa[P->fil][P->col]==FINAL)//ya llegamos!!
            {
               pila->vaciar();
               StatusBar1->SimpleText="Camino (no necesariamente ptimo) encontrado.";
               mostrarRuta();
               return;
            }
         for (int i=0;i<4;i++)
            {
              H=generarHijo(P,i);
              if (H!=NULL && mapa[H->fil][H->col]!=1 && padre[H->fil][H->col]==-1)
              //existe el hijo, es un espacio vacio y no ha sido visitado
                 {
                    padre[H->fil][H->col]=P->fil*numCuadros+P->col;
                    pila->insertar(H);
                 }
            }

      }
   StatusBar1->SimpleText=AnsiString("No se encontr el camino de (")+
   (((AnsiString(inicio.fil)+", ")+inicio.col)+") a (")+
   ((AnsiString(final.fil)+", ")+final.col)+")";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Cargar1Click(TObject *Sender)
{
   if(OpenDialog1->Execute())
      {
         FILE *F;
         int aux;
         F=fopen(OpenDialog1->FileName.c_str(),"r");
         for(int i=0;i<numCuadros;i++)
            for (int j=0;j<numCuadros;j++)
               {
                  fscanf(F,"%d",&aux);
                  colocarCuadrito(aux, i, j);
               }
         fclose(F);
      }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Guardar1Click(TObject *Sender)
{
   if(SaveDialog1->Execute())
      {
         FILE *F;
         F=fopen(SaveDialog1->FileName.c_str(),"w");
         for(int i=0;i<numCuadros;i++)
            {
               for (int j=0;j<numCuadros;j++)
                  fprintf(F,"%d ",mapa[i][j]);
               fprintf(F,"\n");
            }
         fclose(F);
      }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Nuevo1Click(TObject *Sender)
{
   for (int i=0;i<numCuadros;i++)
      for (int j=0;j<numCuadros;j++)
         {
            padre[i][j]=-1;
            mapa[i][j]=0;
            rellenarCuadrito(i,j,clWhite);
            inicioFijo=finalFijo=false;
         }        
}
//---------------------------------------------------------------------------

